// Code generated by gowrap. DO NOT EDIT.
// template: ../../assets/templates/middleware/error_log
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/logs -i Service -t ../../assets/templates/middleware/error_log -o error_logging_middleware.go -l ""

import (
	"context"

	"git.perx.ru/perxis/perxis-go/logs"
	"go.uber.org/zap"
)

// errorLoggingMiddleware implements logs.Service that is instrumented with logging
type errorLoggingMiddleware struct {
	logger *zap.Logger
	next   logs.Service
}

// ErrorLoggingMiddleware instruments an implementation of the logs.Service with simple logging
func ErrorLoggingMiddleware(logger *zap.Logger) Middleware {
	return func(next logs.Service) logs.Service {
		return &errorLoggingMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *errorLoggingMiddleware) Delete(ctx context.Context, filter *logs.Filter) (err error) {
	logger := m.logger
	defer func() {
		if err != nil {
			logger.Warn("response error", zap.Error(err))
		}
	}()
	return m.next.Delete(ctx, filter)
}

func (m *errorLoggingMiddleware) Find(ctx context.Context, filter *logs.Filter, options *logs.FindOptions) (fp1 *logs.FindResult, err error) {
	logger := m.logger
	defer func() {
		if err != nil {
			logger.Warn("response error", zap.Error(err))
		}
	}()
	return m.next.Find(ctx, filter, options)
}

func (m *errorLoggingMiddleware) Log(ctx context.Context, entries []*logs.Entry) (err error) {
	logger := m.logger
	defer func() {
		if err != nil {
			logger.Warn("response error", zap.Error(err))
		}
	}()
	return m.next.Log(ctx, entries)
}
